<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.menu');

class plgPaymentPaybill extends JPlugin
{

	function plgPaymentPaybill(& $subject, $config)
	{
		parent :: __construct($subject, $config);
	}
	function onReceivePayment(&$post)
	{
		global $mainframe;

		if($post['processor'] != 'paybill') return 0;
		$processor_name = 'paybill';
			
		if($post['params'])$params = new JParameter($post['params']);
		else $params = $this->params;

		$out['sid']        = $post['order_id'];
		$out['gateway']    = $post['processor'];
		$out['gateway_id'] = $post['result_gateway_id'];
		$out['user_id']    = @$post['result_user_id'];
		$out['price']      = $post['result_price'];

		if( isset($post['result_key'])
		&& JString::strtoupper( $post['result_key'] ) == JString::strtoupper( md5( $params->get( $processor_name.'_secret_word' ).$out['user_id'].$out['gateway_id'].$out['price'].$post['result_sid'] ) ) ){

			$out['pay'] = str_replace(array('?'), "", $post['result_pay']);

		}else {
			$out['pay'] = 'fail';
			$mainframe->enqueueMessage(JText::_('No valid secret word'));
		}
		//print  "<pre>";	print_r($out); die;
		return $out;
	}

	function onSendPayment(&$post)
	{
		global $mainframe;


		//var_dump( $post );exit;
		$Itemid = @JRequest::getVar('Itemid');

		if($post['processor'] != 'paybill') return false;
		$processor_name = 'paybill';

		if($post['params'])  $params = new JParameter($post['params']);
		else $params = $this->params;

		if(!isset($post['return_success'])){
			$param['option']    = JRequest::getCmd('option');
			$param['task']      = @$post['task'];
			$param['view']      = @$post['view'];
			$param['layout']    = @$post['layout'];
			$param['order_id']  = @$post['order_id'];
			$param['processor'] = @$post['processor'];

			if($params->get('paypaypal_requre'))
			{
				if($params->get('paypaypal_initial_price')) {
					$param['paypaypal_initial_price'] = $params->get('paypaypal_initial_price');
				}
				if($params->get('paypaypal_initial_period')) {
					$param['paypaypal_initial_period_type'] = strtoupper($params->get('paypaypal_initial_period_type'));
					$param['paypaypal_initial_period'] = $params->get('paypaypal_initial_period');
				}
			}
			if($params->get($processor_name.'_local')){
				$return_success  = 'index.php?'.pbillArray2Url($param).'&pay=success';
				$return_fail  = 'index.php?'.pbillArray2Url($param).'&pay=fail';
			}else {
				$return_success  = JURI::base().'index.php?'.pbillArray2Url($param).'&pay=success';
				$return_fail  = JURI::base().'index.php?'.pbillArray2Url($param).'&pay=fail';

			}
			unset($param);

		}else {
			$return_success = @urldecode( $post['return_success'] );
			$return_fail   = @urldecode( $post['return_fail'] );
		}

		$param['return_success'] = base64_encode( $return_success );
		$param['return_fail']    = base64_encode( $return_fail );
			
			
		$param['item_title1'] = $post['order_title'];

		if(isset($post['order_amount']))   $param['item_amount1'] = @$post['order_amount'];
		if(isset($post['amount_change']))  $param['item_amount_change1'] = @$post['amount_change'];

		/*
		 if(isset($post['tax']))            $param['tax'] = @$post['tax'];
		 if(isset($post['tax_change']))     $param['tax_chose'] = @$post['tax_change'];*/

		if($params->get('paybill_tax_use', 0))
		{
			$param[ 'item_tax1'] = $params->get('paybill_tax_rate', 0);
			$param[ 'item_tax_name1'] = $params->get('paybill_tax_name', '');
			$param[ 'chng_item_tax1'] = $params->get('paybill_tax_change', 0);

		}
		if(isset($post['order_id']))   $param['order_number'] = @$post['order_id'];
		if(isset($post['order_id']))   $param['order_id']     = @$post['order_id'];

		$param['currency']     = $params->get('currency');
		$param['price_formats']     = $params->get('layout_price');
			

		if(isset($post['order_quantity'])) $param['item_qnt1'] = @$post['order_quantity'];
		if(isset($post['qnt_change']))     $param['item_qnt_change1'] = @$post['qnt_change'];
		if( isset( $post['Itemid'] ) ) {
			$param['Itemid']  = $post['Itemid'];
		}
		$AParams = $params->toArray();

		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_jcs'.DS.'models');

		$model = &JModel::getInstance( 'Jcs','JcsModel');

		$processors = $model->getProcessors() ;
		$p_elements = array();

		/*foreach ( $processors as $processor ) {
			$p_elements[] = $processor->element;
			}

			foreach( $AParams as $key => $p ) {
			$exploded_key = explode( "_", $key );
			if( in_array( $exploded_key[0], $p_elements ) ) {
			$param['processor['.$key.']'] = $p;
			}
			}*/

		//----
		foreach( $AParams as $key => $p ) {
			if(strstr($key, 'pay'))
			{
				$explode = explode('_', $key);
				$p_elements[$explode[0]] = 1;
			}
		}
		$processors = array_keys($p_elements);
		foreach($processors as $name)
		{
			if($params->get($name.'_enable') != '' && $params->get($name.'_enable') == 0)
			$param['processors['.$name.'_enable]'] = 0;
			else
			{
				foreach( $AParams as $key => $p ) {
					if(strstr($key, $name))
					{
						$param['processors['.$key.']'] = str_replace("\n", '\n', $p);
					}
				}
			}
		}
		//----- ******************

		if( isset( $post['bill_from'] ) ) {
			$param['bill_from'] = @$post['bill_from'];
		} else {
			$param['seller[inv_person]'] = $params->get($processor_name.'_bill_from_additional_person' );
			$param['seller[inv_name]'] = $params->get($processor_name.'_bill_from_name' );
			$param['seller[inv_address]'] = $params->get($processor_name.'_bill_from_address' );
			//seller[inv_city]=
			//seller[inv_country]=
			//seller[inv_state]=
			//seller[inv_zip]=
			$param['seller[inv_tel]'] = $params->get($processor_name.'_bill_from_additional_tel' );
			$param['seller[inv_fax]'] = $params->get($processor_name.'_bill_from_additional_fax' );
			$param['seller[inv_number]'] = $params->get($processor_name.'_bill_from_additional_number' );
			$param['seller[inv_tax_id]'] = $params->get($processor_name.'_bill_from_additional_tax_id' );
			//seller[inv_add]=
		}
		if(isset($post['client']))      $param['client'] = @$post['client'];

		if(isset($post['coption']))     $param['coption'] = JRequest::getCmd('option');

		if(isset($post['access']))       $param['access'] = @$post['access'];

		if(isset($post['saler']))      $param['saler'] = @$post['saler'];

		$txt = '';
		$txt .= '<dl id="system-message">
					<dt class="notice">Message</dt>
					<dd class="notice">
						<ul>
							<li>
							'.JText::_("This page will redirect you to the payment gateway in").' <span id="countDown">5 '.JText::_('seconds').'</span>
							</li>
						</ul>
					</dd>
	  			</dl>';
		$url_base =  $params->get($processor_name.'_local', 1) ? JURI::root() : 'http://'.$params->get($processor_name.'_url_site').'/';
		$txt .= '<form action="'.$url_base.'index.php" method="post" name="formPayBill">';
		foreach ($param as $name => $val)
		{
			$txt .= '<input type="hidden" name="'.$name.'" value="'.$val.'">';
		}
		$txt .= '<input type="hidden" name="option" value="com_jsbill">';
		$txt .= '<input type="hidden" name="view" value="bill">';
		$txt .= '<script type="text/javascript">
				countdown(5);
				function countdown(i)
				{				
					document.getElementById("countDown").innerHTML = i + (i == 1 ? " second": " seconds");
					i = i - 1;
					if(i >= 0)
					setTimeout("countdown(" + i + ")", 1000);
					else
					document.formPayBill.submit();
				}
				</script>
				<noscript>
				<p>'.JText::_('If you are not redirected automatically please click the button Send').'
				<input type="submit" value="'.JText::_('Send').'" class="button">
				</p>
				</noscript>';
		$txt .= '</form>';
		
		echo $txt;
		
		/*if($params->get($processor_name.'_local')){
			$url = JURI::root().'index.php?option=com_jsbill&view=bill&';
			if(strstr($_SERVER["HTTP_USER_AGENT"], 'MSIE'))
			{
			$url .= 'ie=1';
			$_SESSION['paybill']['ie'] = pbillArray2Url( $param );
			}
			else
			{
			$url .= pbillArray2Url( $param );
			}
			$mainframe->redirect($url);
			}else {
			$url = 'http://'.$params->get($processor_name.'_url_site').'/index.php?option=com_jsbill&view=bill&';
			if(strstr($_SERVER["HTTP_USER_AGENT"], 'MSIE'))
			{
			$url .= 'ie=1';
			$_SESSION['paybill']['ie'] = pbillArray2Url( $param );
			}
			else
			{
			$url .= pbillArray2Url( $param );
			}
			$url = str_replace("\n", "", $url);

			header("location: $url");
			}*/

		/*
		 $param['item_name'] = $post['order_title'];

		 if(isset($post['order_amount']))   $param['amount'] = @$post['order_amount'];
		 if(isset($post['amount_change']))  $param['amount_change'] = @$post['amount_change'];

		 if(isset($post['tax']))            $param['tax'] = @$post['tax'];
		 if(isset($post['tax_change']))     $param['tax_chose'] = @$post['tax_change'];

		 if(isset($post['order_number']))   $param['order_number'] = @$post['order_number'];

		 if(isset($post['order_quantity'])) $param['qnt'] = @$post['order_quantity'];
		 if(isset($post['qnt_change']))     $param['qnt_chose'] = @$post['qnt_change'];

		 if(isset($post['processor']))      $param['processor'] = @$post['processor'];

		 if( isset( $post['bill_from'] ) ) {
		 $param['bill_from'] = @$post['bill_from'];
		 } else {
		 $param['bill_from']['name'] = $params->get($processor_name.'_bill_from_name');
		 $param['bill_from']['address'] = $params->get($processor_name.'_bill_from_address');
		 $additional = array(JText::_('Telephone') => $params->get($processor_name.'_bill_from_additional_tel'));
		 $additional = array_merge($additional,array(JText::_('Fax')=>$params->get($processor_name.'_bill_from_additional_fax')));
		 $additional = array_merge($additional,array(JText::_('Company Number')=>$params->get($processor_name.'_bill_from_additional_number')));
		 $additional = array_merge($additional,array(JText::_('Company Tax ID')=>$params->get($processor_name.'_bill_from_additional_tax_id')));
		 $additional = array_merge($additional,array(JText::_('Ask for')=>$params->get($processor_name.'_bill_from_additional_person')));

		 $param['bill_from']['additional'] = $additional;
		 }
		 if(isset($post['client']))      $param['client'] = @$post['client'];

		 if(isset($post['coption']))     $param['coption'] = JRequest::getCmd('option');

		 if(isset($post['access']))       $param['access'] = @$post['access'];

		 if(isset($post['saler']))      $param['saler'] = @$post['saler'];

		 if($params->get($processor_name.'_local')){
		 $mainframe->redirect('inde.php?option=com_bill&view=bill&param='.base64_encode(serialize($param)));
		 }else {
		 $url = 'http://'.$params->get($processor_name.'_url_site').'/index.php?option=com_bill&view=bill&param='.base64_encode(serialize($param));
		 header("location: $url");
		 }*/

	}
}
function pbillArray2Url($param)
{
	foreach($param AS $k => $v)
	{
		$out[] = "$k=$v";
	}
	return implode('&', $out );
}
?>